/*#######################################################
  this is C code for Guassian and binarizaiton
  created        by Y.Fujikawa & L.Meng
  recheck date  20140614 

  add           Otsu method      L.Meng , 2014/10/27
 ########################################################*/
#include<stdio.h>
#include<stdlib.h>
#include<limits.h>
#include<math.h>
#include<string.h>
#include"mypgpm.h"
#define WHITE 255
#define BLACK 0

#define Theshold_Method 1   //1 Otsu method   // 2 Histogram average

int HIST_CNT[256];
char load_file_name[25];  


void binarization(void);
void bubble_sort(void);
int  Otsu_theshold(void); // discriminant analysis method



//***************************************************************//
//   Load and Save the image data
//   void spacial_filtering( )   :: filter processing  
//**************************************************************//
void spacial_filtering( )
// 画像の空間フィルタリングを行う．                     
// Gaussian filter
// 原画像 image1[y][x] ===> 変換後の画像 image2[y][x]   /
{
  double weight[3][3] =
    {  
      {1, 2, 1},
      {2, 4, 2},
      {1, 2, 1},
    };
  double div_const = 1.0; // <== 最後に割る値 
  double pixel_value;     // 計算値 
  double min, max;        // 計算値の最小値，最大値 
  int x, y, i, j;         // ループ変数 
  
  // フィルタリング後の階調値の最小値，最大値を求める 
  printf("make filtering ．\n");
  
  x_size2 = x_size1;  y_size2 = y_size1;
  
  // intial 
  for ( y = 0; y < y_size1 ; y ++ )
    for ( x = 0; x < x_size1 ; x ++ ){
      image2[y][x] = 0;
    }
  
  printf("\n Filtering :\n");
  for ( y = 1; y < y_size1 - 1; y ++ ){
    for ( x = 1; x < x_size1 - 1; x ++ ){
      pixel_value = 0.0;
      
      for (i=-1; i<2; i++)
	for ( j = -1; j < 2; j ++ )
	  {
	    pixel_value = pixel_value +
	      (double)weight[i+1][j+1]*(double)image1[y+i][x+j];
	  }
      
      pixel_value =   pixel_value / 16 ;
      image2[y][x] = (int)pixel_value;
      
      HIST_CNT[image2[y][x]]++;   //histogram counter
    }
  }
}



//*************************************************
//   binarization
//*************************************************
void  binarization(void)
 {
   int i,y,x;
   int Total_Pixel;
   int _Theshold;

   if( Theshold_Method==1)   //0 Otsu method 
     {
       _Theshold = Otsu_theshold(); // discriminant analysis method
     }
   else  if( Theshold_Method==2)   //0 Otsu method 
     {
       _Theshold = Histogram_Average();
     }


   else 
     {
       bubble_sort();
       
       int pixels = y_size1 *  x_size1;
       
       Total_Pixel = (int) ((float)pixels * 0.85); 
       
       printf("******%d\n",Total_Pixel);
       int HIS_Pre=0;
       
       for(i=255;i >= 0;i--)
	 {
	   if( HIS_Pre <= Total_Pixel)  HIS_Pre =  HIS_Pre + HIST_CNT[i];
	   else 	                HIST_CNT[i] = 0;
	 }
       
       for ( y = 1; y < y_size1 - 1; y ++ ){
	 for ( x = 1; x < x_size1 - 1; x ++ ){
	   if( HIST_CNT[image2[y][x]] > 0) image2[y][x] = 255;
	   else  	                   image2[y][x] = 0;
	 }
       }
       
       return ;
     }
   
     
   for ( y = 1; y < y_size1 - 1; y ++ ){
     for ( x = 1; x < x_size1 - 1; x ++ ){
       if (image2[y][x] >= _Theshold)  image2[y][x] = 255;
       else               	       image2[y][x] = 0;
     }
   }
     
 }






void bubble_sort(void){
  int i,j,t;
  // 最後の要素を除いて、すべての要素を並べ替えます
  for(i=0;i<255;i++){
    
    // 下から上に順番に比較します
    for(j=255;j>i;j--){
      
      // 上の方が大きいときは互いに入れ替えます
      if(HIST_CNT[j]<HIST_CNT[j-1]){
	t             = HIST_CNT[j];
	HIST_CNT[j]   = HIST_CNT[j-1];
	HIST_CNT[j-1] = t;
      }
    }
  }
}
  

int Otsu_theshold(void) // discriminant analysis method
{
  int  i,j;
  long  MAX_Pre=0;
  long  MAX=0;
  int  Total_A=0, Total_B=0;
  int  Avg_A=0, Avg_B=0;
  int  Pixel_Nums_A=0,  Pixel_Nums_B=0;
  
  int theshold=0;

  for(i=1;i<=255;i++)
    {
      //initial 
      Total_A=0;         Total_B=0;
      Pixel_Nums_A = 0;  Pixel_Nums_B = 0;
      Avg_A=0;         Avg_B=0;
      MAX_Pre=0;
      // A
      for(j=1;j<=i;j++)
	{
	  if(HIST_CNT[j] !=0)
	    { Total_A = Total_A + HIST_CNT[j]*j;
	      Pixel_Nums_A = Pixel_Nums_A + HIST_CNT[j] ;
	    }
	}
      if(Pixel_Nums_A != 0)   Avg_A = Total_A/Pixel_Nums_A;

      // B
      for(j=i;j<=255;j++)
	{
	  if(HIST_CNT[j] !=0)
	    { Total_B=Total_B + HIST_CNT[j]*j;
	      Pixel_Nums_B =  Pixel_Nums_B +  HIST_CNT[j] ;
	    }
	}
      if(Pixel_Nums_B != 0)   Avg_B = Total_B/Pixel_Nums_B;


      // MAX
      int Sub_AvgA_AvgB = (Avg_A-Avg_B);
      MAX_Pre  = (long)Pixel_Nums_A * (long)Pixel_Nums_B * (long) Sub_AvgA_AvgB * (long)Sub_AvgA_AvgB;

      // printf("PA=%d PB=%d SUB=%d ", Pixel_Nums_A, Pixel_Nums_B, Sub_AvgA_AvgB);

      // printf("Avg_A=%d Avg_B=%d MAX_Pre= %ld, \n", Avg_A,Avg_B, MAX_Pre);
      
      if( MAX < MAX_Pre)
	{ MAX = MAX_Pre; 
	  theshold=i;
	}
    }
  printf("Otsu method Theshold (MAX:%ld) = %d\n ", MAX, theshold);
  return theshold;

}



int Histogram_Average(void)
{
  
  int  Total_AB=0;
  int  Pixel_Nums_AB = 0; 
  int i; 

  for(i=1;i<=255;i++)
    {
      //initial 
          
      if(HIST_CNT[i] !=0)
	{ 
	  Total_AB      = Total_AB + HIST_CNT[i]*i;
	  Pixel_Nums_AB = Pixel_Nums_AB + HIST_CNT[i] ;
	}

      printf("%d %d %d \n",HIST_CNT[i],Total_AB,Pixel_Nums_AB);
    }
  
  if(Pixel_Nums_AB==0){ printf("this image just a black backgroud!!!\n"); exit(0); }
  else 
    {
      printf("Histogram average method Theshold = %d\n ",  Total_AB/Pixel_Nums_AB);
      return Total_AB/Pixel_Nums_AB;
    } 
}





//**************************************************************************
//       main  function 
//**************************************************************************
int main( int argc,char *argv[])
{
  char    buf[1024];
  int    i, size;
 
  if(argv[1]==NULL)
    {
      printf("input the original image (*.pgm):");
      scanf("%s",load_file_name);
    } 
  else 
    {
      strncpy(load_file_name,argv[1],25); 
      printf("load_file_name=%s,%s=argv[1]",load_file_name,argv[1]); 
    }
  
 
  load_image_data();   // 画像を読み込んで image1 へ 
  spacial_filtering();
  binarization();
  strcpy(save_file_name,"Bin.pgm");
  save_image_data();
 

  return 0;
}




